package hk.quantr.fs.Dialogs;

import hk.quantr.fs.Global;
import hk.quantr.fs.PExceptionDialog;
import hk.quantr.fs.PFSTreeModel;
import java.awt.BorderLayout;
import java.awt.Point;
import java.io.File;
import java.io.FileWriter;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTree;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class AutoGenerateDialog2 extends javax.swing.JDialog implements Runnable {

	boolean stopThread;
	BorderLayout borderLayout6 = new BorderLayout();
	JPanel pProgressPanel = new JPanel();
	JScrollPane pProgressScrollPane = new JScrollPane();
	JTable pProgressTable = new JTable();
	WriteDialog_TableModel pWriteDialog_TableModel = new WriteDialog_TableModel();
	JTree jDirectoryTree;
	String projectFile;

	/**
	 * Creates new form AutoGenerateDialog2
	 */
	public AutoGenerateDialog2(JFrame jMainFrame, JTree jDirectoryTree, String projectFile) {
		super(jMainFrame, true);
		this.jDirectoryTree = jDirectoryTree;
		this.projectFile = projectFile;
		initComponents();

		pProgressPanel.setLayout(borderLayout6);
		pProgressPanel.add(pProgressScrollPane, java.awt.BorderLayout.CENTER);
		pProgressTable.setModel(pWriteDialog_TableModel);
		pProgressScrollPane.getViewport().add(pProgressTable);
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        buttonGroup3 = new javax.swing.ButtonGroup();
        buttonGroup4 = new javax.swing.ButtonGroup();
        pMainPanel = new javax.swing.JPanel();
        pTypeLabel = new javax.swing.JLabel();
        pFileRadioButton = new javax.swing.JRadioButton();
        pDirectoryRadioButton = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        pPrefixTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        pFromTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        pToTextField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        pSteJTextField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        JRadioButton1 = new javax.swing.JRadioButton();
        pFileContentFromTextField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        pFileContentToTextField = new javax.swing.JTextField();
        JRadioButton2 = new javax.swing.JRadioButton();
        pFileContentTextField = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        pSameAsFilenameRadioButton = new javax.swing.JRadioButton();
        pFixedSizeRadioButton = new javax.swing.JRadioButton();
        pFilesizeTextField = new javax.swing.JTextField();
        pByteRadioButton = new javax.swing.JRadioButton();
        pKBRadioButton = new javax.swing.JRadioButton();
        pMBRadioButton = new javax.swing.JRadioButton();
        pFSPermissionPanel = new hk.quantr.fs.PFSPermissionPanel();
        pFSOwnerPanel = new hk.quantr.fs.PFSOwnerPanel();
        pControlPanel = new javax.swing.JPanel();
        pWarningLabel = new javax.swing.JLabel();
        pOKButton = new javax.swing.JButton();
        pCancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setSize(new java.awt.Dimension(400, 300));

        pMainPanel.setLayout(new java.awt.GridBagLayout());

        pTypeLabel.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        pTypeLabel.setText("Type");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pTypeLabel, gridBagConstraints);

        buttonGroup1.add(pFileRadioButton);
        pFileRadioButton.setSelected(true);
        pFileRadioButton.setText("File");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pFileRadioButton, gridBagConstraints);

        buttonGroup1.add(pDirectoryRadioButton);
        pDirectoryRadioButton.setText("Directory");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pDirectoryRadioButton, gridBagConstraints);

        jLabel1.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        jLabel1.setText("Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(jLabel1, gridBagConstraints);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("Prefix");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(jLabel2, gridBagConstraints);

        pPrefixTextField.setText("file");
        pPrefixTextField.setPreferredSize(new java.awt.Dimension(50, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pPrefixTextField, gridBagConstraints);

        jLabel3.setText("From");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(jLabel3, gridBagConstraints);

        pFromTextField.setText("0");
        pFromTextField.setPreferredSize(new java.awt.Dimension(50, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pFromTextField, gridBagConstraints);

        jLabel4.setText("To");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(jLabel4, gridBagConstraints);

        pToTextField.setText("10");
        pToTextField.setPreferredSize(new java.awt.Dimension(50, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pToTextField, gridBagConstraints);

        jLabel5.setText("Step");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(jLabel5, gridBagConstraints);

        pSteJTextField.setText("1");
        pSteJTextField.setPreferredSize(new java.awt.Dimension(50, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pSteJTextField, gridBagConstraints);

        jLabel6.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        jLabel6.setText("File Content");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(jLabel6, gridBagConstraints);

        buttonGroup2.add(JRadioButton1);
        JRadioButton1.setSelected(true);
        JRadioButton1.setText("From");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(JRadioButton1, gridBagConstraints);

        pFileContentFromTextField.setText("0");
        pFileContentFromTextField.setPreferredSize(new java.awt.Dimension(50, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pFileContentFromTextField, gridBagConstraints);

        jLabel7.setText("To");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(jLabel7, gridBagConstraints);

        pFileContentToTextField.setText("9");
        pFileContentToTextField.setPreferredSize(new java.awt.Dimension(50, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pFileContentToTextField, gridBagConstraints);

        buttonGroup2.add(JRadioButton2);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(JRadioButton2, gridBagConstraints);

        pFileContentTextField.setText("0");
        pFileContentTextField.setPreferredSize(new java.awt.Dimension(50, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pFileContentTextField, gridBagConstraints);

        jLabel8.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        jLabel8.setText("File Size");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(jLabel8, gridBagConstraints);

        buttonGroup3.add(pSameAsFilenameRadioButton);
        pSameAsFilenameRadioButton.setSelected(true);
        pSameAsFilenameRadioButton.setText("Base on file name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pSameAsFilenameRadioButton, gridBagConstraints);

        buttonGroup3.add(pFixedSizeRadioButton);
        pFixedSizeRadioButton.setText("Fixed size");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pFixedSizeRadioButton, gridBagConstraints);

        pFilesizeTextField.setText("1");
        pFilesizeTextField.setPreferredSize(new java.awt.Dimension(50, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pFilesizeTextField, gridBagConstraints);

        buttonGroup4.add(pByteRadioButton);
        pByteRadioButton.setSelected(true);
        pByteRadioButton.setText("Byte");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        pMainPanel.add(pByteRadioButton, gridBagConstraints);

        buttonGroup4.add(pKBRadioButton);
        pKBRadioButton.setText("KB");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        pMainPanel.add(pKBRadioButton, gridBagConstraints);

        buttonGroup4.add(pMBRadioButton);
        pMBRadioButton.setText("MB");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 5;
        pMainPanel.add(pMBRadioButton, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pFSPermissionPanel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        pMainPanel.add(pFSOwnerPanel, gridBagConstraints);

        getContentPane().add(pMainPanel, java.awt.BorderLayout.CENTER);

        pControlPanel.add(pWarningLabel);

        pOKButton.setText("OK");
        pOKButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pOKButtonActionPerformed(evt);
            }
        });
        pControlPanel.add(pOKButton);

        pCancelButton.setText("Cancel");
        pCancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pCancelButtonActionPerformed(evt);
            }
        });
        pControlPanel.add(pCancelButton);

        getContentPane().add(pControlPanel, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void pOKButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pOKButtonActionPerformed
		if (pOKButton.getText().equals("OK")) {
			this.getContentPane().remove(pMainPanel);
			getContentPane().add(pProgressPanel, BorderLayout.EAST);
			this.getContentPane().validate();
			pOKButton.setText("Stop");

			stopThread = false;
			new Thread(this).start();
		} else if (pOKButton.getText().equals("Resume")) {
			pOKButton.setText("Stop");
			stopThread = false;
		} else {
			stopThread = true;
			pOKButton.setText("Resume");
		}

    }//GEN-LAST:event_pOKButtonActionPerformed

    private void pCancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pCancelButtonActionPerformed
		File currentDirectory = (File) jDirectoryTree.getLastSelectedPathComponent();
		((PFSTreeModel) jDirectoryTree.getModel()).fireTreeStructureChanged(currentDirectory);
		this.setVisible(false);
    }//GEN-LAST:event_pCancelButtonActionPerformed

	public void run() {
		pWarningLabel.setText("");
		File currentDirectory = (File) jDirectoryTree.getLastSelectedPathComponent();
		try {
			int from = Integer.parseInt(pFromTextField.getText());
			int to = Integer.parseInt(pToTextField.getText());
			int step = Integer.parseInt(pSteJTextField.getText());
			String prefix = pPrefixTextField.getText();

			if (pFileRadioButton.isSelected()) {
				for (int x = from; x <= to; x += step) {
					try {
						while (stopThread) {
							Thread.currentThread().sleep(1000);
						}
						if (this.isVisible() == false) {
							return;
						}
						String filename = currentDirectory + File.separator + prefix + x;
						pWriteDialog_TableModel.add(filename, "");
						pProgressScrollPane.getViewport().setViewPosition(new Point(0, pProgressTable.getMaximumSize().height));

						new File(filename).createNewFile();
						if (pSameAsFilenameRadioButton.isSelected()) {
							writeFileContent(filename, x);
						} else {
							long size = Long.parseLong(pFilesizeTextField.getText());
							if (pKBRadioButton.isSelected()) {
								size *= 1024;
							}
							if (pMBRadioButton.isSelected()) {
								size *= 1024 * 1024;
							}

							writeFileContent(filename, size);
						}

						pWriteDialog_TableModel.setValueAt("done", pWriteDialog_TableModel.getRowCount() - 1, 1);

						pFSPermissionPanel.writeIni(filename);
						pFSOwnerPanel.writeIni(filename);
					} catch (Exception ex) {
						pWriteDialog_TableModel.setValueAt("fail", pWriteDialog_TableModel.getRowCount() - 1, 1);
					}
				}
			} else {
				for (int x = from; x <= to; x += step) {
					while (stopThread) {
						Thread.currentThread().sleep(1000);
					}
					if (this.isVisible() == false) {
						return;
					}

					String filename = currentDirectory + File.separator + prefix + x;
					pWriteDialog_TableModel.add(filename, "");
					pProgressScrollPane.getViewport().setViewPosition(new Point(0, pProgressTable.getMaximumSize().height));

					new File(filename).mkdir();
					pWriteDialog_TableModel.setValueAt("done", pWriteDialog_TableModel.getRowCount() - 1, 1);
				}
			}
		} catch (Exception ex2) {
			ex2.printStackTrace();
			if (Global.GUI) {
				new PExceptionDialog(ex2, Global.sessionNumber).setVisible(true);
			}
		}
		// update tree
		pOKButton.setVisible(false);
		pCancelButton.setVisible(false);
		pWarningLabel.setText("Please wait, updating the tree");
		((PFSTreeModel) jDirectoryTree.getModel()).fireTreeStructureChanged(currentDirectory);
		this.setVisible(false);
	}

	private void writeFileContent(String filename, long size) throws Exception {
		FileWriter fw = new FileWriter(filename);
		char fromChar = pFileContentFromTextField.getText().charAt(0);
		char toChar = pFileContentToTextField.getText().charAt(0);
		char c = fromChar;
		char buffer[] = new char[1024 * 1024];
		// for (int index = 0; index < size; index++) {
		// if (stopThread || this.isVisible() == false) {
		// pOKButton.setText("OK");
		// return;
		// } else if (JRadioButton1.isSelected()) {
		// fw.write(c);
		// fw.flush();
		// c++;
		// if (c == toChar + 1) {
		// c = fromChar;
		// }
		// } else {
		// fw.write(pFileContentTextField.getText().charAt(0));
		// }
		// if (index % (1024 * 1024 - 1) == 0) {
		// pWriteDialog_TableModel.setValueAt((index + 1) / 1024 / 1024 +
		// "MB written",
		// pWriteDialog_TableModel.getRowCount() - 1, 1);
		// }
		// }
		int bufferIndex = 0;
		for (int index = 0; index < size; index++) {
			while (stopThread) {
				Thread.currentThread().sleep(1000);
			}
			if (this.isVisible() == false) {
				return;
			}

			if (JRadioButton1.isSelected()) {
				// fw.write(c);
				// fw.flush();
				buffer[bufferIndex] = c;
				c++;
				if (c == toChar + 1) {
					c = fromChar;
				}
			} else {
				buffer[bufferIndex] = pFileContentTextField.getText().charAt(0);
				// fw.write(pFileContentTextField.getText().charAt(0));
			}
			bufferIndex++;
			if (bufferIndex == buffer.length) {
				fw.write(buffer);
				pWriteDialog_TableModel.setValueAt((index + 1) / 1024 / 1024 + "MB written", pWriteDialog_TableModel.getRowCount() - 1, 1);
				bufferIndex = 0;
			}
		}
		fw.write(buffer, 0, bufferIndex);
		fw.close();
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton JRadioButton1;
    private javax.swing.JRadioButton JRadioButton2;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.ButtonGroup buttonGroup3;
    private javax.swing.ButtonGroup buttonGroup4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JRadioButton pByteRadioButton;
    private javax.swing.JButton pCancelButton;
    private javax.swing.JPanel pControlPanel;
    private javax.swing.JRadioButton pDirectoryRadioButton;
    private hk.quantr.fs.PFSOwnerPanel pFSOwnerPanel;
    private hk.quantr.fs.PFSPermissionPanel pFSPermissionPanel;
    private javax.swing.JTextField pFileContentFromTextField;
    private javax.swing.JTextField pFileContentTextField;
    private javax.swing.JTextField pFileContentToTextField;
    private javax.swing.JRadioButton pFileRadioButton;
    private javax.swing.JTextField pFilesizeTextField;
    private javax.swing.JRadioButton pFixedSizeRadioButton;
    private javax.swing.JTextField pFromTextField;
    private javax.swing.JRadioButton pKBRadioButton;
    private javax.swing.JRadioButton pMBRadioButton;
    private javax.swing.JPanel pMainPanel;
    private javax.swing.JButton pOKButton;
    private javax.swing.JTextField pPrefixTextField;
    private javax.swing.JRadioButton pSameAsFilenameRadioButton;
    private javax.swing.JTextField pSteJTextField;
    private javax.swing.JTextField pToTextField;
    private javax.swing.JLabel pTypeLabel;
    private javax.swing.JLabel pWarningLabel;
    // End of variables declaration//GEN-END:variables
}
